require 'logicbomb/mailer'

module LogicBomb
  class Ping
    def initialize(ping:, tracert:, interval:, mailer:)
      @ping = ping
      @tracert = tracert
      @interval = interval
      @mailer = mailer
    end

    def daemon
      while true
        sleep @interval
        netconns = ping
        next if netconns.nil?
        mailer.mail netconns, tracert
        sleep 3600
      end
    end

    private
    def ping
      @ping.each do |ip| 
        attempt1 = ping ip
        next if successful_ping?(ip)
        sleep 5
        attempt2 = ping ip
        return "#{attempt1}\n#{attempt2}" unless successful_ping?(attempt2)
      end
    end

    def tracert
      @tracert.map {|ip| "#{ip}:\n" + `traceroute #{ip}`}.join('\n')
    end

    def ping(ip)
      `ping -c 1 -s 1 #{ip}`
    end

    def successful_ping?(stdout)
      stdout.include?(" 0% packet loss,")
    end
  end
end
